# LedD.GO
[![][license img]][license]

LedD is a multipurpose daemon for interfacing LED(s) written in GO. It provides an abstract, protobuf based protocol for clients to control any kind of LED through an backend, although its original purpose was interfacing a PCA9685 chip via i2c. Since there are multiple ways to control leds we made the decision to write LedD as open as possible to other ways of controlling leds. As a result of this decision we split LedD in a server part (this repository) and multiple clients, which can be written in any kind of language and can use a custom way to control its LEDs, as long as they implement LedD's protobuf protocol they can be controled with LedD.

As for frontends there is only an Android app available at this time, there will be more some time in the future. (You are encouraged to write your own!)

## Requirements

- Compatible backend to control leds; currently available backends include:
    - PCA9685
- __Note__: Backends can have different permission requirements

## Installation

TODO

### Plugins & Effects

'Plugin' functionality is provided as you can connect as many clients as you wish. Here are some we are going to provide when they are finished.

- fade
- strobe (as far as possible)
- music effect generation (far away as for now)
    
#### License

This project is licensed under the conditions of the GNU GPL 3.0.

[license]:LICENSE
[license img]:https://img.shields.io/github/license/led-freaks/ledd.go.svg?style=flat-square
